module SomeToolkit
  class ColumnList
    def initialize( n )
      @cols = n
      @buf = []
    end

    attr_reader :cols

    def rows
      @buf.size
    end

    def freeze
      @buf.clear
    end

    def unfreeze
      @buf.each do |cols|
        printf '%-15s ' * cols.size, * cols.collect {|i| i[0,15] }
        puts
      end
    end

    def append_row( items )
      @buf.push items
    end

    def set_string( row, col, str )
      (@buf[row] ||= [])[col] = str
    end

    def set_pixmap( row, col, pm )
      (@buf[row] ||= [])[col] = pm ? pm : '-'
    end
  end

  class Pixmap
    def self.new( fname )
      fname ? '*' : '-'
    end
  end
end
